/*
 * This file is a part of fmtx-faker: Tricks fmtxd into thinking the transmitter is not disabled.
 *
 * Copyright (C) 2009-2010 Faheem Pervez <trippin1@gmail.com>. All rights reserved.
 *
 *             DO WHAT THE FUCK YOU WANT TO PUBLIC LICENSE
 *                   Version 2, December 2004
 *
 *	Copyright (C) 2004 Sam Hocevar
 *	14 rue de Plaisance, 75014 Paris, France
 *	Everyone is permitted to copy and distribute verbatim or modified
 *	copies of this license document, and changing it is allowed as long
 *	as the name is changed.
 *
 *           DO WHAT THE FUCK YOU WANT TO PUBLIC LICENSE
 *  TERMS AND CONDITIONS FOR COPYING, DISTRIBUTION AND MODIFICATION
 *
 * 	0. You just DO WHAT THE FUCK YOU WANT TO. 
 *
 * This program is free software. It comes without any warranty, to
 * the extent permitted by applicable law. You can redistribute it
 * and/or modify it under the terms of the Do What The Fuck You Want
 * To Public License, Version 2, as published by Sam Hocevar. See
 * http://sam.zoy.org/wtfpl/COPYING for more details.
 *
 */
 
/* fmtx-faker-preemp-tool.c */ 

#define FMTX_PWL_KEY "fmtx_pwl"
/* #define FCC "fcc"
#define ETSI "etsi"
#define ANFR "anfr" */

#include <stdlib.h>
#include <cal.h>
#include <glib.h>
#include <glib/gprintf.h>

#if 0 /* Writing isn't implemented because I do not know if it is possible to do so. */
static gchar *new_preemp = NULL;

static GOptionEntry entries[] = 
{
	{"set-preemp", 0, 0, G_OPTION_ARG_STRING, &new_preemp, "Write the given value to " FMTX_PWL_KEY "key", FCC "/" ETSI "/" ANFR},
	{NULL}
};

static void write_pwl_mode (gulong len)
{
	struct cal *cal_s;
	GString *fmtx_pwl_mode_buf;
	gsize new_len;

	if (cal_init (&cal_s) < 0)
	{
		g_printerr ("Failed to init CAL.\n");
		exit (EXIT_FAILURE);
	}

	if (len == )
	if (cal_write_block (cal_s, FMTX_PWL_KEY, &new_preemp, sizeof (fmtx_pwl_mode), 0) < 0)
	{
		cal_finish (cal_s);
		g_printerr ("Failed to write to " FMTX_PWL_KEY " in CAL.\n");
		exit (EXIT_FAILURE);
	}

	cal_finish (cal_s);
	
	g_free (new_preemp);
}
#endif

static gulong read_pwl_mode (void)
{
	struct cal *cal_s;
	gpointer tmp = NULL;
	gchar *fmtx_pwl_mode;
	gulong len;

	if (cal_init (&cal_s) < 0)
	{
		g_printerr ("Failed to init CAL.\n");
		exit (EXIT_FAILURE);
	}

	if (cal_read_block (cal_s, FMTX_PWL_KEY, &tmp, &len, 0) < 0)
	{
		cal_finish (cal_s);
		g_printerr ("Failed to read " FMTX_PWL_KEY " from CAL.\n");
		exit (EXIT_FAILURE);
	}

	if (len < 1 && !fmtx_pwl_mode)
	{
        cal_finish (cal_s);
		g_printerr ("Failed to read " FMTX_PWL_KEY " from CAL.\n");
		exit (EXIT_FAILURE);
	}

	fmtx_pwl_mode = (gchar *) tmp;

	g_printf ("Current pre-emphasis mode: %s\n\n", fmtx_pwl_mode);

	free (fmtx_pwl_mode);

    cal_finish (cal_s);
    
    return len;
}

gint main (gint argc, gchar *argv[])
{
	gulong len = 0;
	/* GOptionContext *context = g_option_context_new (NULL);
	g_option_context_set_summary (context, "fmtx-faker-preemp-tool: View the current pre-emphasis mode");
	g_option_context_add_main_entries (context, entries, NULL);

	if (!g_option_context_parse (context, &argc, &argv, NULL))
	{
		g_printerr ("Error parsing options.");
		return EXIT_FAILURE;
	}

	g_option_context_free (context); */

	len = read_pwl_mode ();

	/* if ((new_preemp && new_preemp[0] != '\0') && (g_str_equal (new_preemp, FCC) || g_str_equal (new_preemp, ETSI) || g_str_equal (new_preemp, ANFR)))
		write_pwl_mode (len); */

	return EXIT_SUCCESS;
}
